/*
    Move To Layer Out
        あかつきみさき

    このスクリプトについて
        現在時間を選択しているレイヤーの最も遅いアウトポイント時間に移動するスクリプト.

    使用方法
        ファイル→スクリプト→スクリプトファイルの実行から実行.

    バージョン情報
        2024/04/02 Ver 1.0.0 Release
*/

/// <reference path="D:\lib\aftereffects.d.ts\ae.d.ts"/>
(function () {
    var actComp = app.project.activeItem;
    if (actComp == null || !(actComp instanceof CompItem)) {
        return 0;
    }

    var furthestOutPoint = 0;
    for (var i = 0; i < actComp.selectedLayers.length; i++) {
        var curLayer = actComp.selectedLayers[i];
        var outPoint = curLayer.outPoint;
        if (outPoint > furthestOutPoint) {
            furthestOutPoint = outPoint;
        }
    }

    if (actComp.selectedLayers.length == 0) {
        for (var i = 1; i <= actComp.numLayers; i++) {
            var curLayer = actComp.layer(i);
            var outPoint = curLayer.outPoint;
            if (outPoint > furthestOutPoint) {
                furthestOutPoint = outPoint;
            }
        }
    }

    actComp.time = furthestOutPoint;
    return 0;
}).call(this);
